(function() {
  var FSEvents, fs, _path;
  fs = require('fs');
  FSEvents = require("fsevents");
  _path = require('path');
  module.exports = function(base, options, callback) {
    var cache, cwd, directories, ignore, paths, self, skip, source, stat, _i, _len;
    global.fse = new FSEvents(base);
    paths = require('findit').sync(base);
    cache = {};
    self = this;
    cwd = process.cwd();
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    options || (options = {});
    ignore = options.ignore || [];
    skip = function(path) {
      var ignored, _i, _len;
      for (_i = 0, _len = ignore.length; _i < _len; _i++) {
        ignored = ignore[_i];
        if (path.match(ignored)) {
          return true;
        }
      }
      return false;
    };
    for (_i = 0, _len = paths.length; _i < _len; _i++) {
      source = paths[_i];
      if (skip()) {
        continue;
      }
      stat = fs.statSync(source);
      if (!stat.isDirectory()) {
        cache[_path.join(cwd, source.replace(cwd, ""))] = stat;
      }
    }
    directories = {};
    return fse.on("change", function(path, flags, evtid, asdf) {
      var action, curr, deleted, entries, entry, file, prev, relative, timestamp, _j, _len2;
      entries = fs.readdirSync(path);
      action = null;
      timestamp = new Date;
      if (directories[path] && entries.length < directories[path].length) {
        action = "delete";
        deleted = directories[path].filter(function(i) {
          return !(entries.indexOf(i) > -1);
        });
        directories[path] = entries;
        relative = _path.join(path, deleted[0]).replace(process.cwd().toString() + '/', '');
        console.log("" + (timestamp.toLocaleTimeString()) + " - " + action + "d " + relative);
        try {
          callback.call(self, relative, null, null, action, timestamp);
        } catch (error) {
          console.log(error.message);
        }
        return;
      }
      directories[path] = entries;
      for (_j = 0, _len2 = entries.length; _j < _len2; _j++) {
        entry = entries[_j];
        if (!(entry === '.' || entry === '..')) {
          file = _path.join(path, entry);
          curr = fs.statSync(file);
          if (!curr.isDirectory()) {
            prev = cache[file];
            if (!(prev && curr.size === prev.size && curr.mtime.getTime() === prev.mtime.getTime())) {
              if (!prev) {
                action || (action = "create");
              } else {
                action || (action = "update");
              }
              cache[file] = curr;
              relative = file.replace(process.cwd().toString() + '/', '');
              console.log("" + (timestamp.toLocaleTimeString()) + " - " + action + "d " + relative);
              try {
                callback.call(self, file, prev, curr, action, timestamp);
              } catch (error) {
                console.log(error.message);
              }
            }
          }
        }
      }
      if (fs.statSync("stop")) {
        console.log("Stop");
        fs.unlinkSync("stop");
        return fse.stop();
      }
    });
  };
}).call(this);
