fs              = require 'fs'
FSEvents        = require("fsevents")
_path           = require 'path'

module.exports  = (base, options, callback) ->
  global.fse    = new FSEvents(base)
  paths         = require('findit').sync(base) # fs.readdirSync(base)
  cache         = {}
  self          = @
  cwd           = process.cwd()
  if typeof options == "function"
    callback = options
    options  = {}
  options ||= {}
  ignore = options.ignore || []
  
  skip = (path) ->
    for ignored in ignore
      return true if path.match(ignored)
    return false
  
  for source in paths
    continue if skip()
    
    stat = fs.statSync(source)
    
    unless stat.isDirectory()
      cache[_path.join(cwd, source.replace(cwd, ""))] = stat
      
  directories = {}
  
  fse.on "change", (path, flags, evtid, asdf) ->
    entries   = fs.readdirSync(path)
    action    = null
    timestamp = new Date
    
    if directories[path] && entries.length < directories[path].length
      action  = "delete"
      deleted = directories[path].filter (i) -> !(entries.indexOf(i) > -1)
      directories[path] = entries
      relative    = _path.join(path, deleted[0]).replace(process.cwd().toString() + '/', '')
      console.log "#{timestamp.toLocaleTimeString()} - #{action}d #{relative}"
      try
        callback.call(self, relative, null, null, action, timestamp)
      catch error
        console.log error.message
      return
    
    directories[path] = entries
      
    for entry in entries
      unless entry == '.' || entry == '..'
        file = _path.join(path, entry)
        curr = fs.statSync(file)
        unless curr.isDirectory()
          prev = cache[file]
          unless prev && curr.size == prev.size && curr.mtime.getTime() == prev.mtime.getTime()
            if !prev
              action ||= "create"
            else
              action ||= "update"
            cache[file] = curr
            relative    = file.replace(process.cwd().toString() + '/', '')
            console.log "#{timestamp.toLocaleTimeString()} - #{action}d #{relative}"
            try
              callback.call(self, file, prev, curr, action, timestamp)
            catch error
              console.log error.message
          
    if fs.statSync("stop")
      console.log "Stop"
      fs.unlinkSync "stop"
      fse.stop()